#ifndef _BITMAP_H_
#define _BITMAP_H

#define LE16(p) ((((p&0x00ff))<<8) | ((p&0xff00)>>8))
#define LE32(p) ((((p&0x000000ff))<<24) | (((p&0x0000ff00))<<8) | (((p&0x00ff0000))>>8) | ((p&0xff000000)>>24))

struct BMP_Head
{
  byte                  id[2];
  dword                 size;
  dword                 reserved;
  dword                 offset;
}__attribute__((__packed__));

struct BMP_Info
{
  long                  info_size;
  long                  width;
  long                  height;
  word                  plane;
  word                  bits_per_pixel;
  long                  compress;
  long                  img_size;
  long                  x_res;
  long                  y_res;
  long                  color;
  long                  icolor;
}__attribute__((__packed__));

#define _R(y,u,v) (0x2568*(y)			   + 0x3343*(u)) /0x2000
#define _G(y,u,v) (0x2568*(y) - 0x0c92*(v) - 0x1a1e*(u)) /0x2000
#define _B(y,u,v) (0x2568*(y) + 0x40cf*(v)) 			 /0x2000

#define _S(a)		(a)>255 ? 255 : (a)<0 ? 0 : (a)

extern __inline void YUV2RGB(word yy, word uu, word vv, byte *r, byte *g, byte *b);
extern int convert_bitmap_1555_24(word *bitmap1555, int width, int height, byte *bitmap24);
extern int convert_bitmap_1555_16(word *bitmap1555, int width, int height, byte *bitmap16);
extern int convert_bitmap_8_1555(byte *bitmap8, byte *palette, int width, int height, word *bitmap1555);
extern int save_bitmap(int bytes_per_pixel, byte *bitmap, int width, int height);
extern int load_bitmap();

#endif
